/**
 * Transform hats to custom values.
 */
converse.plugins.add('sib-custom-hats', {
  overrides: {
    getHats: function() {
      const hat_conversions = { 'admin': 'Administrateur' };
      const hats = this.__super__.getHats.apply(this, arguments);
      if (!hat_conversions) {
        return hats;
      } else {
        const role_affiliations = Object.keys(hat_conversions);
        return hats.map((hat) => {
          if (role_affiliations.includes(hat.title)) {
            return ({ title: hat_conversions[hat.title] });
          } else {
            return hat;
          }
        });
      }
    },
  },
});
