const componentName = "chat"; //TODO: Get it from the packages.json

export function path() {
  let path = ".";
  if (window.orbit) {
    let component = window.orbit.npm.find(
      (e) => e.package == `@startinblox/component-${componentName}`
    );
    // WARN: do not copy me for other component. I'm tweaked.
    path = `https://cdn.jsdelivr.net/npm/${component.package}@${component.version}`;
    if (component.path) {
      path = component.path.replace("/index.js", "");
    }
  }
  return path;
}

export function coreVersion() {
  let coreUrl =
    "https://cdn.jsdelivr.net/npm/@startinblox/core@0.19/dist/index.js";
  if (window.orbit) {
    let core = window.orbit.npm.find((e) => e.package == "@startinblox/core");
    coreUrl = `https://cdn.jsdelivr.net/npm/@startinblox/core@${core.version}/dist/index.js`;
    if (core.path) {
      coreUrl = core.path;
    }
  }
  return coreUrl;
}

export function setupOrbit(component) {
  if (window.orbit) {
    component.localize = (key) => {
      if (!key in component.strings) {
        console.warn(`Missing location string: ${key}`);
      }
      return (
        window.orbit.intl.t(`${componentName}.${key}`) ||
        component.strings[key] ||
        key
      );
    };
    component.getRoute = window.orbit.getRoute;
  } else {
    component.getRoute = () => componentName;
  }
}

export function uniq() {
  return Math.random().toString(16).slice(2);
}

export class Deferred {
  constructor() {
    this.promise = new Promise(
      function (resolve, reject) {
        this.resolve = resolve;
        this.reject = reject;
      }.bind(this)
    );
    this.then = this.promise.then.bind(this.promise);
    this.catch = this.promise.catch.bind(this.promise);
  }
}

/**
 * Returns TRUE if the current device has touch features (mobile).
 * @return {boolean}
 */
export const isTouchDevice = () => "ontouchstart" in document.documentElement;

/**
 * Promise that resolves once the document is fully ready.
 * @return {Promise}
 */
export function documentReady() {
  if (document.readyState === "loading") {
    return new Promise((resolve) => {
      document.addEventListener("DOMContentLoaded", () => resolve());
    });
  }
  return Promise.resolve();
}
